# (C) Copyright 2024 Beijing Academy of Quantum Information Sciences
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
"""Element gates."""
from .element_gates import (
    CPGate,
    CRXGate,
    CRYGate,
    CRZGate,
    CSGate,
    CTGate,
    CXGate,
    CYGate,
    CZGate,
    FredkinGate,
    HGate,
    IdGate,
    ISwapGate,
    MCXGate,
    MCYGate,
    MCZGate,
    PhaseGate,
    RXGate,
    RXXGate,
    RYGate,
    RYYGate,
    RZGate,
    RZZGate,
    SdgGate,
    SGate,
    SwapGate,
    SWdgGate,
    SWGate,
    SXdgGate,
    SXGate,
    SYdgGate,
    SYGate,
    TdgGate,
    TGate,
    ToffoliGate,
    U3Gate,
    WGate,
    XGate,
    YGate,
    ZGate,
)

__all__ = [
    "XGate",
    "YGate",
    "ZGate",
    "IdGate",
    "WGate",
    "HGate",
    "SGate",
    "SdgGate",
    "TGate",
    "TdgGate",
    "SXGate",
    "SXdgGate",
    "SYGate",
    "SYdgGate",
    "SWGate",
    "SWdgGate",
    "RXGate",
    "RYGate",
    "RZGate",
    "PhaseGate",
    "RXXGate",
    "RYYGate",
    "RZZGate",
    "SwapGate",
    "ISwapGate",
    "CXGate",
    "CYGate",
    "CZGate",
    "CSGate",
    "CTGate",
    "CPGate",
    "CRXGate",
    "CRYGate",
    "CRZGate",
    "ToffoliGate",
    "FredkinGate",
    "MCXGate",
    "MCYGate",
    "U3Gate",
    "MCZGate",
]
